# Do not modify this file!  It was generated by ‘nixos-generate-config’
# and may be overwritten by future invocations.  Please make changes
# to /etc/nixos/configuration.nix instead.
{ config, lib, pkgs, modulesPath, ... }:

{
  imports = [ (modulesPath + "/installer/scan/not-detected.nix") ];

  boot.initrd.availableKernelModules = [ "xhci_pci" "ahci" "nvme" "usbhid" ];
  boot.initrd.kernelModules = [ "i915" ];
  boot.kernelModules = [ "kvm-intel" ];

  fileSystems."/" =
    { device = "none";
      fsType = "tmpfs";
      options = [ "defaults" "size=8G" "mode=755" ];
    };

  fileSystems."/boot" =
    { device = "/dev/disk/by-uuid/909C-CE7E";
      fsType = "vfat";
    };

  # system
  boot.initrd.luks.devices."crypt-system".device = "/dev/disk/by-uuid/27c4619d-4e60-458e-95ad-e348a7894a14";

  # projects
  boot.initrd.luks.devices."crypt-projects".device = "/dev/disk/by-id/nvme-Samsung_SSD_980_PRO_2TB_S69ENF0R846614L";

  # vms
  boot.initrd.luks.devices."crypt-vms".device = "/dev/disk/by-id/nvme-CT2000P5PSSD8_213330E4ED05";

  fileSystems."/nix" =
    { device = "/dev/mapper/crypt-system";
      fsType = "btrfs";
      options = [ "subvol=nix" "noatime" "nodiratime" ];
    };

  fileSystems."/data" =
    { device = "/dev/mapper/crypt-system";
      fsType = "btrfs";
      options = [ "subvol=data" "noatime" "nodiratime" ];
    };

  fileSystems."/home" =
    {
      depends = [ "/data" ];
      device = "/data/home";
      fsType = "none";
      options = [ "bind" ];
    };

  fileSystems."/root" =
    {
      depends = [ "/data" ];
      device = "/data/root";
      fsType = "none";
      options = [ "bind" ];
    };

  fileSystems."/etc/nixos" =
    {
      depends = [ "/data" ];
      device = "/data/nixos/neko";
      fsType = "none";
      options = [ "bind" ];
    };

  fileSystems."/home/cullmann/projects" =
    {
      depends = [ "/home" ];
      device = "/dev/mapper/crypt-projects";
      fsType = "btrfs";
      options = [ "noatime" "nodiratime" ];
    };

  fileSystems."/home/cullmann/vms" =
    {
      depends = [ "/home" ];
      device = "/dev/mapper/crypt-vms";
      fsType = "btrfs";
      options = [ "noatime" "nodiratime" ];
    };

  nixpkgs.hostPlatform = lib.mkDefault "x86_64-linux";
  hardware.cpu.intel.updateMicrocode = lib.mkDefault config.hardware.enableRedistributableFirmware;
}
